//+------------------------------------------------------------------+
//|                                                      HLStats.mq5 |
//|                                    Copyright 2011, EarnForex.com |
//|                                     http://www.earnforex.com.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, EarnForex.com"
#property link      "http://www.earnforex.com.com"
#property version   "1.01"
#property script_show_inputs

//--- input parameters
input int PipsMultiplier = 10000; // PipsMultiplier - 10000 for EUR/USD, 100 for USD/JPY
input int GMT_Difference  = 1;
input int BarsToCount = 80000; // BarsToCount - How many bars to count starting from the most recent one

double High[];
double Low[];
datetime Time[];

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
   int bars = Bars(NULL, 0);
   Print("Chart contains " + IntegerToString(bars) + " bars.");
   if (CopyTime(NULL, 0, 0, bars, Time) != bars) Print("Failed to copy Time array.");
   if (CopyHigh(NULL, 0, 0, bars, High) != bars) Print("Failed to copy High array.");
   if (CopyLow(NULL, 0, 0, bars, Low) != bars) Print("Failed to copy Low array.");
   
   int filehandle = FileOpen("stats.csv", FILE_WRITE|FILE_CSV);
   if (filehandle == INVALID_HANDLE)
   {
      Print("Failed to open file: ", GetLastError());
      return;
   }

   MqlDateTime dt;

   double hl_volatility[24];
   int n[24];

   ArrayInitialize(hl_volatility, 0);
   ArrayInitialize(n, 0);

   for (int i = bars - BarsToCount; i < bars; i++)
   {
      TimeToStruct(Time[i], dt);
      int hour = dt.hour;
      hour -= GMT_Difference;
      if (hour < 0) hour += 24;
      hl_volatility[hour] += High[i] - Low[i];
      n[hour]++;
   }
   
   for (int i = 0; i < 24; i++)
      FileWrite(filehandle, DoubleToString(hl_volatility[i] / n[i] * PipsMultiplier, 1));
   FileClose(filehandle);
}
//+------------------------------------------------------------------+